package ZSK.b4a.LongPressGesture;

import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Events;

@BA.Version(1.0F)
@BA.ShortName("LongPressGesture")
@BA.Author("ZSK")
@Events(values = {
		"onLongPressConfirmed(X As Float, Y As Float, MotionEvent As Object)",
		"onLongPress(X As Float, Y As Float, MotionEvent As Object)"
})
public class LongPressGesture {
	private GestureDetector mGestureDetector;
	private BA _ba;
	private String _eventPrefix;
	private View _view;
	private boolean LongPressing;

	public void SetOnGestureListener(BA ba, View view, String eventPrefix)
	{
		_ba = ba;
		_view = view;
		_eventPrefix = eventPrefix.toLowerCase();
		LongPressing = false;
		mGestureDetector = new GestureDetector(ba.context, new GestureListener());

		OnTouchListener OTL = new View.OnTouchListener()
		{
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				final int action = event.getAction();
				if (action == 0) {
					LongPressing = false;
				}
				else if (action == 1) {
					if (LongPressing == true)
					{
						if (_ba.subExists(_eventPrefix + "_onlongpressconfirmed"))
						{
							LongPressing = false;
							_ba.raiseEvent(_view, _eventPrefix + "_onlongpressconfirmed", new Object[] {event.getX(), event.getY(), event});
						}
					}
				}
				
				mGestureDetector.onTouchEvent(event);
				return true;
			}
		};
		view.setOnTouchListener(OTL);
	}

	/** Removes all gesture listeners for the currently bound view. */
	public void RemoveGestureListener()
	{
		_view.setOnTouchListener(null);
	}

	private class GestureListener extends GestureDetector.SimpleOnGestureListener
	{
		public void onLongPress(MotionEvent ev)
		{
			if (_ba.subExists(_eventPrefix + "_onlongpress"))
			{
				LongPressing = true;
				_ba.raiseEvent(_view, _eventPrefix + "_onlongpress", new Object[] {Float.valueOf(ev.getX()), Float.valueOf(ev.getY()), ev});
			}
		}
	}

	private static int getAction(MotionEvent ev)
	{
		return ev.getAction();
	}

	private static float getX(MotionEvent ev, int ptrIndex)
	{
		return ev.getX(ptrIndex);
	}

	private static float getY(MotionEvent ev, int ptrIndex)
	{
		return ev.getY(ptrIndex);
	}

}
